ReplaceRegExp (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.taskdefs.optional, class: ReplaceRegExp

# Class ReplaceRegExp

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.Task
org.apache.tools.ant.taskdefs.optional.ReplaceRegExp

All Implemented Interfaces:
  `Cloneable`

public class ReplaceRegExp extends Task
Performs regular expression string replacements in a text file. The input file(s) must be able to be properly processed by a Reader instance. That is, they must be text only, no binary. The syntax of the regular expression depends on the implementation that you choose to use. The system property `ant.regexp.regexpimpl` will be the classname of the implementation that will be used (the default is `org.apache.tools.ant.util.regexp.JakartaOroRegexp` and requires the Jakarta Oro Package).

    Available implementations:

      org.apache.tools.ant.util.regexp.Jdk14RegexpRegexp (default)
           Uses Java's built-in regular expression package

      org.apache.tools.ant.util.regexp.JakartaOroRegexp
           Requires  the jakarta-oro package

      org.apache.tools.ant.util.regexp.JakartaRegexpRegexp
           Requires the jakarta-regexp package

    Usage:

      Call Syntax:

        <replaceregexp file="file"
                       match="pattern"
                       replace="pattern"
                       flags="options"?
                       byline="true|false"?
                       failOnError="true|false"? >
          regexp?
          substitution?
          fileset*
        </replaceregexp>

       NOTE: You must have either the file attribute specified, or at least one fileset subelement
       to operation on.  You may not have the file attribute specified if you nest fileset elements
       inside this task.  Also, you cannot specify both match and a regular expression subelement at
       the same time, nor can you specify the replace attribute and the substitution subelement at
       the same time.

      Attributes:

        file    --> A single file to operation on (mutually exclusive
                       with the fileset subelements)
        match   --> The Regular expression to match
        replace --> The Expression replacement string
        flags   --> The options to give to the replacement
                    g = Substitute all occurrences. default is to replace only the first one
                    i = Case insensitive match

        byline  --> Should this file be processed a single line at a time (default is false)
                    "true" indicates to perform replacement on a line by line basis
                    "false" indicates to perform replacement on the whole file at once.

        failOnError --> Should this task fail if an error occurs (default is false)
                    "true" indicates that this task should fail if an error occurs
                    "false" indicates that this task should continue if an error occurs

     Example:

        The following call could be used to replace an old property name in a ".properties"
        file with a new name.  In the replace attribute, you can refer to any part of the
        match expression in parenthesis using backslash followed by a number like '\1'.

        <replaceregexp file="test.properties"
                       match="MyProperty=(.*)"
                       replace="NewProperty=\1"
                       byline="true" />

- ## Field Summary

  ### Fields inherited from class Task

  `target, taskName, taskType, wrapper`
  Modifier and Type
  Field
  Description
  `protected Target`
  `target`
  Deprecated.
  since 1.6.x.
  `protected String`
  `taskName`
  Deprecated.
  since 1.6.x.
  `protected String`
  `taskType`
  Deprecated.
  since 1.6.x.
  `protected RuntimeConfigurable`
  `wrapper`
  Deprecated.
  since 1.6.x.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ReplaceRegExp()`
  Default Constructor

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addConfigured(ResourceCollection rc)`
  Support arbitrary file system based resource collections.
  `void`
  `addFileset(FileSet set)`
  list files to apply the replacement to
  `RegularExpression`
  `createRegexp()`
  A regular expression.
  `Substitution`
  `createSubstitution()`
  A substitution pattern.
  `protected void`
  `doReplace(File f, int options)`
  Perform the replacement on a file
  `protected String`
  `doReplace(RegularExpression r, Substitution s, String input, int options)`
  Invoke a regular expression (r) on a string (input) using substitutions (s) for a matching regex.
  `void`
  `execute()`
  Execute the task
  `void`
  `setByLine(boolean byline)`
  Process the file(s) one line at a time, executing the replacement on one line at a time.
  `void`
  `setByLine(String byline)`
  Deprecated.
  since 1.6.x.
  `void`
  `setEncoding(String encoding)`
  Specifies the encoding Ant expects the files to be in - defaults to the platforms default encoding.
  `void`
  `setFailOnError(boolean failonerror)`
  If false, note errors but continue.
  `void`
  `setFile(File file)`
  file for which the regular expression should be replaced; required unless a nested fileset is supplied.
  `void`
  `setFlags(String flags)`
  The flags to use when matching the regular expression.
  `void`
  `setMatch(String match)`
  the regular expression pattern to match in the file(s); required if no nested <regexp> is used
  `void`
  `setPreserveLastModified(boolean b)`
  Whether the file timestamp shall be preserved even if the file is modified.
  `void`
  `setReplace(String replace)`
  The substitution pattern to place in the file(s) in place of the regular expression.

  ### Methods inherited from class Task

  `bindToOwner, getOwningTarget, getRuntimeConfigurableWrapper, getTaskName, getTaskType, getWrapper, handleErrorFlush, handleErrorOutput, handleFlush, handleInput, handleOutput, init, isInvalid, log, log, log, log, maybeConfigure, perform, reconfigure, setOwningTarget, setRuntimeConfigurableWrapper, setTaskName, setTaskType`
  Modifier and Type
  Method
  Description
  `final void`
  `bindToOwner(Task owner)`
  Bind a task to another; use this when configuring a newly created task to do work on behalf of another.
  `Target`
  `getOwningTarget()`
  Returns the container target of this task.
  `RuntimeConfigurable`
  `getRuntimeConfigurableWrapper()`
  Returns the wrapper used for runtime configuration.
  `String`
  `getTaskName()`
  Returns the name to use in logging messages.
  `String`
  `getTaskType()`
  Return the type of task.
  `protected RuntimeConfigurable`
  `getWrapper()`
  Return the runtime configurable structure for this task.
  `protected void`
  `handleErrorFlush(String output)`
  Handles an error line by logging it with the WARN priority.
  `protected void`
  `handleErrorOutput(String output)`
  Handles an error output by logging it with the WARN priority.
  `protected void`
  `handleFlush(String output)`
  Handles output by logging it with the INFO priority.
  `protected int`
  `handleInput(byte[] buffer, int offset, int length)`
  Handle an input request by this task.
  `protected void`
  `handleOutput(String output)`
  Handles output by logging it with the INFO priority.
  `void`
  `init()`
  Called by the project to let the task initialize properly.
  `protected final boolean`
  `isInvalid()`
  Has this task been marked invalid?
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `log(String msg, Throwable t, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `log(Throwable t, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `maybeConfigure()`
  Configures this task - if it hasn't been done already.
  `final void`
  `perform()`
  Performs this task if it's still valid, or gets a replacement version and performs that otherwise.
  `void`
  `reconfigure()`
  Force the task to be reconfigured from its RuntimeConfigurable.
  `void`
  `setOwningTarget(Target target)`
  Sets the target container of this task.
  `void`
  `setRuntimeConfigurableWrapper(RuntimeConfigurable wrapper)`
  Sets the wrapper to be used for runtime configuration.
  `void`
  `setTaskName(String name)`
  Sets the name to use in logging messages.
  `void`
  `setTaskType(String type)`
  Sets the name with which the task has been invoked.

  ### Methods inherited from class ProjectComponent

  `clone, getDescription, getLocation, getProject, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `Object`
  `clone()`
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### ReplaceRegExp

    public ReplaceRegExp()
    Default Constructor

- ## Method Details

  - ### setFile

    public void setFile(File file)
    file for which the regular expression should be replaced; required unless a nested fileset is supplied.
    Parameters:
      `file` - The file for which the reg exp should be replaced.

  - ### setMatch

    public void setMatch(String match)
    the regular expression pattern to match in the file(s); required if no nested <regexp> is used
    Parameters:
      `match` - the match attribute.

  - ### setReplace

    public void setReplace(String replace)
    The substitution pattern to place in the file(s) in place of the regular expression. Required if no nested <substitution> is used
    Parameters:
      `replace` - the replace attribute

  - ### setFlags

    public void setFlags(String flags)
    The flags to use when matching the regular expression. For more information, consult the Perl5 syntax.
    - g : Global replacement. Replace all occurrences found
    - i : Case Insensitive. Do not consider case in the match
    - m : Multiline. Treat the string as multiple lines of input, using "^" and "$" as the start or end of any line, respectively, rather than start or end of string.
    - s : Singleline. Treat the string as a single line of input, using "." to match any character, including a newline, which normally, it would not match.
    Parameters:
      `flags` - the flags attribute

  - ### setByLine

    @Deprecated public void setByLine(String byline)
    Deprecated.
    since 1.6.x. Use setByLine(boolean).
    Process the file(s) one line at a time, executing the replacement on one line at a time. This is useful if you want to only replace the first occurrence of a regular expression on each line, which is not easy to do when processing the file as a whole. Defaults to false.
    Parameters:
      `byline` - the byline attribute as a string

  - ### setByLine

    public void setByLine(boolean byline)
    Process the file(s) one line at a time, executing the replacement on one line at a time. This is useful if you want to only replace the first occurrence of a regular expression on each line, which is not easy to do when processing the file as a whole. Defaults to false.
    Parameters:
      `byline` - the byline attribute

  - ### setEncoding

    public void setEncoding(String encoding)
    Specifies the encoding Ant expects the files to be in - defaults to the platforms default encoding.
    Parameters:
      `encoding` - the encoding attribute
    Since:
      Ant 1.6

  - ### addFileset

    public void addFileset(FileSet set)
    list files to apply the replacement to
    Parameters:
      `set` - the fileset element

  - ### addConfigured

    public void addConfigured(ResourceCollection rc)
    Support arbitrary file system based resource collections.
    Parameters:
      `rc` - ResourceCollection
    Since:
      Ant 1.8.0

  - ### createRegexp

    public RegularExpression createRegexp()
    A regular expression. You can use this element to refer to a previously defined regular expression datatype instance
    Returns:
      the regular expression object to be configured as an element

  - ### createSubstitution

    public Substitution createSubstitution()
    A substitution pattern. You can use this element to refer to a previously defined substitution pattern datatype instance.
    Returns:
      the substitution pattern object to be configured as an element

  - ### setPreserveLastModified

    public void setPreserveLastModified(boolean b)
    Whether the file timestamp shall be preserved even if the file is modified.
    Parameters:
      `b` - boolean
    Since:
      Ant 1.8.0

  - ### setFailOnError

    public void setFailOnError(boolean failonerror)
    If false, note errors but continue.
    Parameters:
      `failonerror` - true or false
    Since:
      Ant 1.10.15

  - ### doReplace

    protected String doReplace(RegularExpression r, Substitution s, String input, int options)
    Invoke a regular expression (r) on a string (input) using substitutions (s) for a matching regex.
    Parameters:
      `r` - a regular expression
      `s` - a Substitution
      `input` - the string to do the replacement on
      `options` - The options for the regular expression
    Returns:
      the replacement result

  - ### doReplace

    protected void doReplace(File f, int options) throws IOException
    Perform the replacement on a file
    Parameters:
      `f` - the file to perform the replacement on
      `options` - the regular expressions options
    Throws:
      `IOException` - if an error occurs

  - ### execute

    public void execute() throws BuildException
    Execute the task
    Overrides:
      `execute` in class `Task`
    Throws:
      `BuildException` - is there is a problem in the task execution.